apiVersion: tekton.dev/v1beta1
kind: Task
metadata:
  labels:
    {{ network_policy_deployment_label }}: job-{{ tekton_name }}
    version: "{{ tekton_assets_version }}"
  name: scan-image-trivy
  namespace: {{ buildns }}
spec:
  params:
  - name: dstimage
    description: Image to Scan
    type: string
  steps:
  - args:
    - -c
    - |
        echo "==== Scanning $(params.dstimage) ===="
{% if k8s_flavor == 'openshift' %}
        export TRIVY_USERNAME={{ pipeline_sa }}
        export TRIVY_PASSWORD="$(cat /var/run/secrets/kubernetes.io/serviceaccount/token)"
{% elif docker_registry_token | default(False) %}
        export TRIVY_USERNAME={{ docker_registry_token }}
{% elif docker_registry_is_http | default(False) %}
        export TRIVY_NON_SSL=true
{% endif %}
        for retry in 1 2 3;
        do
{% if trivy_api_address | default(False) %}
            if ! trivy image --server "{{ trivy_api_address }}" \
                     -f json -o /tmp/scan-output \
                     --timeout 10m0s \
                     "$(params.dstimage)"; then
                echo "==== Returned $? ===="
            fi
{% else %}
            if ! trivy image -f json -o /tmp/scan-output \
                     --timeout 10m0s \
                    "$(params.dstimage)"; then
                echo "==== Returned $? ===="
            fi
{% endif %}
            if ! test -s /tmp/scan-output; then
                rm -f /tmp/scan-output
                if test "$retry" -ge 3; then
                    echo "==== Failed scanning image ===="
                    exit 1
                else
                    echo "=== Retrying in 10s ==="
                    sleep 10
                fi
            else
                break
            fi
        done
        echo "==== Done scanning - parsing output ===="
        for level in CRITICAL HIGH LOW MEDIUM UNKNOWN
        do
            echo "==== Listing criticity '$level' ===="
            cat /tmp/scan-output | jq ".Results[].Vulnerabilities[] | select(.Severity == \"$level\")" 2>/dev/null
            count=$(cat /tmp/scan-output | jq "(.Results[].Vulnerabilities[] | select(.Severity == \"$level\")).VulnerabilityID" 2>/dev/null | sort -u | awk 'END{print NR}')
            eval count$level=$count
        done
        rm -f /tmp/scan-output
        if ! test "$countCRITICAL" = 0; then
            score=CRITICAL
        elif ! test "$countHIGH" = 0; then
            score=WARNING
        else
            score=OK
        fi
        echo =============================================
        echo =============================================
        echo =============================================
        echo "[$score] $(params.dstimage)"
        echo ""
        echo " * critical: $countCRITICAL"
        echo " * high: $countHIGH"
        echo " * low: $countLOW"
        echo " * medium: $countMEDIUM"
        echo " * unknown: $countUNKNOWN"
    command:
    - /bin/sh
    image: {{ (opsimages | json_query("[?name=='jkagtrivy'].image"))[0] }}
    name: scan-image
{% if tekton_uses_resources_limits | default(False) %}
    resources:
      limits:
        cpu: "{{ tekton_trivy_cpu_limit }}"
        memory: {{ tekton_trivy_memory_limit }}
      requests:
        cpu: "{{ tekton_trivy_cpu_request }}"
        memory: {{ tekton_trivy_memory_request }}
{% else %}
    resources: {}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
    securityContext:
{% if 0 == 1 %}
      runAsUser: {{ k8s_unprivileged_userid }}
{% else %}
      privileged: true
{% endif %}
{% endif %}
